<!--
  ~ #%L
  ~ chvote-bo
  ~ %%
  ~ Copyright (C) 2016 - 2019 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<mat-card id="milestoneEdit" class="parameter-edit" [class.read-only]="cardReadOnly"
>
  <mat-card-header>
    <mat-card-title>{{'parameters.milestone.edit.title' | translate}}</mat-card-title>
    <mat-card-subtitle fxLayout="row" fxLayoutAlign="space-between">
      <span>{{'parameters.milestone.edit.subtitle' | translate}}</span>
      <span *ngIf="!readOnly">{{'global.forms.fields.required' | translate}}</span>
    </mat-card-subtitle>
  </mat-card-header>
  <mat-card-content>

    <form [formGroup]="milestonesForm" novalidate>

      <h3 class="md-title">{{'parameters.milestone.edit.before-vote' | translate}}</h3>
      <div fxLayout="row wrap"  fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="1 1 26rem"
                        *ngFor="let milestone of ['SITE_VALIDATION', 'CERTIFICATION', 'PRINTER_FILES', 'BALLOT_BOX_INIT']"
                        [class.input-in-error]="milestonesForm.get(milestone).touched
                          && (milestonesForm.get(milestone).hasError('matDatepickerMin') || milestonesForm.get(milestone).hasError('invalidDate'))">
          <mat-placeholder>{{'parameters.milestone.edit.form.fields.' + milestone + '.placeholder' | translate}}
          </mat-placeholder>
          <mat-datetimepicker-toggle [for]="milestoneDatepicker" matSuffix></mat-datetimepicker-toggle>
          <mat-datetimepicker #milestoneDatepicker type="date"></mat-datetimepicker>
          <input matInput
                 id="{{milestone + '_Input'}}"
                 [formControlName]="milestone"
                 [matDatetimepicker]="milestoneDatepicker"
                 (focus)="milestonesForm.get(milestone).markAsUntouched()"
                 [min]="now"
                 autocomplete=false>
          <mat-error
            *ngIf="milestonesForm.get(milestone).touched && milestonesForm.get(milestone).hasError('required')">
            <span>{{'global.forms.errors.required' | translate}}</span>
          </mat-error>
          <mat-error
            *ngIf="milestonesForm.get(milestone).touched && milestonesForm.get(milestone).hasError('matDatepickerMin')">
            <span>{{'parameters.milestone.edit.form.errors.past-date' | translate}}</span>
          </mat-error>
          <mat-error *ngIf="milestonesForm.get(milestone).hasError('invalidDate')">
            <span>{{milestonesForm.get(milestone).getError('invalidDate').message}}</span>
          </mat-error>
        </mat-form-field>
      </div>

      <h3 class="md-title">{{'parameters.milestone.edit.during-vote' | translate}}</h3>
      <div fxLayout="row wrap" fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="1 1 26rem"
                        *ngFor="let milestone of ['SITE_OPEN', 'SITE_CLOSE']">
          <mat-placeholder>{{'parameters.milestone.edit.form.fields.' + milestone + '.placeholder' | translate}}
          </mat-placeholder>
          <mat-datetimepicker-toggle [for]="milestoneDatepicker" matSuffix></mat-datetimepicker-toggle>
          <mat-datetimepicker #milestoneDatepicker type="datetime"></mat-datetimepicker>
          <input matInput
                 id="{{milestone + '_Input'}}"
                 [formControlName]="milestone"
                 [matDatetimepicker]="milestoneDatepicker"
                 (focus)="milestonesForm.get(milestone).markAsUntouched()"
                 [min]="now"
                 required
                 autocomplete=false>
          <mat-error
            *ngIf="milestonesForm.get(milestone).touched && milestonesForm.get(milestone).hasError('required')">
            <span>{{'global.forms.errors.required' | translate}}</span>
          </mat-error>
          <mat-error
            *ngIf="milestonesForm.get(milestone).touched && milestonesForm.get(milestone).hasError('matDatepickerMin')">
            <span>{{'parameters.milestone.edit.form.errors.past-date' | translate}}</span>
          </mat-error>
          <mat-error *ngIf="milestonesForm.get(milestone).hasError('invalidDate')">
            <span>{{milestonesForm.get(milestone).getError('invalidDate').message}}</span>
          </mat-error>
        </mat-form-field>

        <mat-form-field id="gracePeriodInput" fxFlex="1 1 26rem">
          <input matInput
                 type="number"
                 name="gracePeriodInput"
                 formControlName="gracePeriod"
                 min="0"
                 max="60"
                 placeholder="{{'parameters.milestone.edit.form.fields.grace-period.placeholder' | translate}}"
                 required>
          <mat-error
            *ngIf="milestonesForm.get('gracePeriod').touched && milestonesForm.get('gracePeriod').hasError('required')">
            <span>{{'global.forms.errors.required' | translate}}</span>
          </mat-error>
          <mat-error
            *ngIf="milestonesForm.get('gracePeriod').touched && (milestonesForm.get('gracePeriod').hasError('min') || milestonesForm.get('gracePeriod').hasError('max'))">
            <span>{{'parameters.milestone.edit.form.fields.grace-period.errors.min-max-value' | translate}}</span>
          </mat-error>
        </mat-form-field>
      </div>

      <h3 class="md-title" style="padding-top: 10px">{{'parameters.milestone.edit.after-vote' | translate}}</h3>
      <div fxLayout="row wrap" fxLayoutGap="2.5rem">
        <mat-form-field fxFlex="1 1 26rem"
                        *ngFor="let milestone of ['BALLOT_BOX_DECRYPT', 'RESULT_VALIDATION', 'DATA_DESTRUCTION']">
          <mat-placeholder>{{'parameters.milestone.edit.form.fields.' + milestone + '.placeholder' | translate}}
          </mat-placeholder>
          <mat-datetimepicker-toggle [for]="milestoneDatepicker" matSuffix></mat-datetimepicker-toggle>
          <mat-datetimepicker #milestoneDatepicker
                              type="{{milestone == 'BALLOT_BOX_DECRYPT' ? 'datetime' : 'date'}}"></mat-datetimepicker>
          <input matInput
                 id="{{milestone + '_Input'}}"
                 [formControlName]="milestone"
                 [matDatetimepicker]="milestoneDatepicker"
                 (focus)="milestonesForm.get(milestone).markAsUntouched()"
                 [min]="now"
                 [required]="milestone === 'BALLOT_BOX_DECRYPT'"
                 autocomplete=false>
          <mat-error
            *ngIf="milestonesForm.get(milestone).touched && milestonesForm.get(milestone).hasError('required')">
            <span>{{'global.forms.errors.required' | translate}}</span>
          </mat-error>
          <mat-error
            *ngIf="milestonesForm.get(milestone).touched && milestonesForm.get(milestone).hasError('matDatepickerMin')">
            <span>{{'parameters.milestone.edit.form.errors.past-date' | translate}}</span>
          </mat-error>
          <mat-error *ngIf="milestonesForm.get(milestone).hasError('invalidDate')">
            <span>{{milestonesForm.get(milestone).getError('invalidDate').message}}</span>
          </mat-error>
        </mat-form-field>
      </div>

    </form>
  </mat-card-content>
  <mat-card-actions *ngIf="!readOnly">
    <div fxLayout fxLayoutAlign="end" fxLayoutGap="25px">
      <button mat-button
              id="clearButton"
              color="warn"
              [disabled]="!operation.milestones || operation.milestones.length == 0"
              (click)="clear()">
        <mat-icon>clear</mat-icon>
        {{'parameters.milestone.edit.actions.clear' | translate | uppercase}}
      </button>
      <button mat-raised-button
              [disabled]="!isFormModified()"
              id="saveButton"
              color="primary"
              (click)="save()">{{'global.actions.save' | translate | uppercase}}
      </button>
    </div>
  </mat-card-actions>
</mat-card>
